import com.google.inject.AbstractModule;
import com.google.inject.Guice;
import com.google.inject.Inject;
import com.google.inject.Injector;
import com.google.inject.Scopes;

/**
   Guice 1.0 Tv
   Copyright (C) 2007 Masanori OKIBAYASHI All rights reserved.
 **/
public class GuiceSample1  {

  public interface Play  {
    void play();
  }

  static class PlayImpl implements Play  {
    public void play()  {
      System.out.println( "Ă!" );
    }
  }

  static class Baseball implements Play  {
    public void play()  {
      System.out.println( "싅Ă!" );
    }
  }

  static class Soccer implements Play  {
    public void play()  {
      System.out.println( "TbJ[Ă!" );
    }
  }

  class PlayModule extends AbstractModule  {
    protected void configure()  {
      bind( Play.class ).to( PlayImpl.class ).in( Scopes.SINGLETON );
      // bind( Play.class ).to( Baseball.class ).in( Scopes.SINGLETON );
      // bind( Play.class ).to( Soccer.class ).in( Scopes.SINGLETON );
    }
  }

  class Player implements Play  {

    private final Play play;

    @Inject
    public Player( Play play )  {
      this.play = play;
    }

    public void play()  {
      play.play();
    }

  }

  public void start() throws Exception  {
    Injector injector = Guice.createInjector( new PlayModule() );
    Play play = injector.getInstance( Player.class );
    play.play();
  }
  
  public static void main( String[] argv ) throws Exception  {
    GuiceSample1 gs1 = new GuiceSample1();
    gs1.start();
  }

}