import com.google.inject.AbstractModule;
import com.google.inject.Guice;
import com.google.inject.ImplementedBy;
import com.google.inject.Inject;
import com.google.inject.Injector;
// import com.google.inject.Scopes;
import com.google.inject.Singleton;

/**
   Guice 1.0 Tv
   Copyright (C) 2007 Masanori OKIBAYASHI All rights reserved.
 **/
public class GuiceSample2  {

  // @ImplementedBy( PlayImpl.class )
  @ImplementedBy( Baseball.class )
  // @ImplementedBy( Soccer.class )
  public interface Play  {
    void play();
  }

  @Singleton
  static class PlayImpl implements Play  {
    public void play()  {
      System.out.println( "Play!" );
    }
  }

  static class Baseball implements Play  {
    public void play()  {
      System.out.println( "Play Baseball!" );
    }
  }

  static class Soccer implements Play  {
    public void play()  {
      System.out.println( "Play Soccer!" );
    }
  }
/*
  static class PlayModule extends AbstractModule  {
    protected void configure()  {
      bind( Play.class ).to( PlayImpl.class ).in( Scopes.SINGLETON );
      // bind( Play.class ).to( Baseball.class ).in( Scopes.SINGLETON );
      // bind( Play.class ).to( Soccer.class ).in( Scopes.SINGLETON );
    }
  }
*/
  class Player  {
    private final Play play;

    @Inject
    public Player( Play play )  {
      this.play = play;
    }

    public void play()  {
      play.play();
    }

  }

  public static void main( String[] argv ) throws Exception  {
    // Injector injector = Guice.createInjector( new PlayModule() );
    Injector injector = Guice.createInjector();
    Player player = injector.getInstance( Player.class );
    player.play();
  }

}