import com.google.inject.AbstractModule;
import com.google.inject.Guice;
import com.google.inject.Inject;
import com.google.inject.Injector;

import com.google.inject.name.Named;

import static com.google.inject.name.Names.*;

/**
   Guice 1.0 Tv
   Copyright (C) 2007 Masanori OKIBAYASHI All rights reserved.
 **/
public class GuiceSample3  {

  public static void main( String[] argv ) throws Exception  {

    Injector injector = Guice.createInjector( new AbstractModule() {
      protected void configure()  {
      /*
        bind( int.class ).annotatedWith( named( "perfect" ) ).toInstance( 100 );
        bind( int.class ).annotatedWith( named( "high"    ) ).toInstance(  80 );
        bind( int.class ).annotatedWith( named( "passing" ) ).toInstance(  60 );
      */
        bindConstant().annotatedWith( named( "perfect" ) ).to( "100" );
        bindConstant().annotatedWith( named( "high"    ) ).to(  80 );
        bindConstant().annotatedWith( named( "passing" ) ).to(  60 );
      }
    });

    Exam exam = injector.getInstance( Exam.class );

    System.out.printf( "_ = %d, _ = %d, i_ = %d\n",
                       exam.perfect, exam.high, exam.passing );

  }

}

  class Exam  {
    @Inject public Exam()  {}
    @Inject @Named("perfect") int perfect;  // _
    @Inject @Named("high")    int high;     // _
    @Inject @Named("passing") int passing;  // i_
  }
