import com.google.inject.AbstractModule;
import com.google.inject.Guice;
import com.google.inject.Injector;
import com.google.inject.Provider;

import com.google.inject.name.Named;

import static com.google.inject.name.Names.*;

/**
   Guice 1.0 Tv
   Copyright (C) 2007 Masanori OKIBAYASHI All rights reserved.
 **/
public class GuiceSample4  {

  public static void main( String[] argv ) throws Exception  {

    Injector injector = Guice.createInjector( new AbstractModule() {
      protected void configure()  {
        bind( Order.class ).toProvider( new OrderProvider( 1 ) );
      }
    });

    Order o1 = injector.getInstance( Order.class );
    Order o2 = injector.getInstance( Order.class );
    Order o3 = injector.getInstance( Order.class );

    System.out.printf( "J[gID = %d, %d, %d\n",
      o1.getCartId(), o2.getCartId(), o3.getCartId() );

  }

}

class Cart  {
  int id;
  public Cart( int id )  { this.id = id; }
}

class Order  {
  Cart cart;
  public Order( Cart cart )  {  this.cart = cart;  }
  public int getCartId()  {
    return cart.id;
  }
}

class OrderProvider implements Provider<Order>  {
  int id = 0;
  public OrderProvider( int id )  {  this.id = id;  }
  public Order get()  {
    return  new Order( new Cart( id++ ) );
  }
}