import java.io.IOException;
import java.io.PrintWriter;
import java.io.OutputStreamWriter;

import java.util.Map;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.google.inject.AbstractModule;
import com.google.inject.Guice;
import com.google.inject.Inject;
import com.google.inject.Injector;
import com.google.inject.servlet.RequestParameters;
import com.google.inject.servlet.RequestScoped;
import com.google.inject.servlet.ServletModule;
import com.google.inject.servlet.SessionScoped;

/**
   Guice 1.0 Tv
   Copyright (C) 2007 Masanori OKIBAYASHI All rights reserved.
 **/
public class GuiceSample6 extends HttpServlet  {

  Injector injector;
  Monitor  monitor;

  public void init( ServletConfig config ) throws ServletException  {
    super.init( config );
    injector = Guice.createInjector( new AbstractModule() {
      protected void configure() {
        install( new ServletModule() );
        bind( Monitor.class );
      }
    });
  }

  public void doGet( HttpServletRequest req, HttpServletResponse res )
                throws IOException, ServletException  {
    doPost( req, res );
  }

  public void doPost( HttpServletRequest req, HttpServletResponse res )
                throws IOException, ServletException  {

    Monitor monitor = injector.getInstance( Monitor.class );
    monitor.display();

    String echo = req.getParameter( "echo" );
    String encoding = req.getCharacterEncoding();
    if ( encoding == null )  encoding = "JISAutoDetect";
    echo = ( echo == null ) ?
            "͂ꂽbZ[Wɕ\܂" :
            new String( echo.getBytes( "ISO-8859-1" ), encoding );

    res.setContentType( "text/html;charset=Shift_JIS" );

    PrintWriter out = new PrintWriter(
                          new OutputStreamWriter(
                              res.getOutputStream(), "Shift_JIS" ) );

    out.println("<html>");
    out.println("<head>");
    out.println("<title>GR[(T[ubg)</title>");
    out.println("</head>");
    out.println("<body>");
    out.println("<form method=\"post\" action=\"GuiceSample6\">");
    out.println("<input type=\"text\" name=\"echo\" size=\"50\" value=\"" +
                  echo + "\">");
    out.println("<input type=\"submit\" value=\"bZ[WM\">");
    out.println("</form>");
    out.println("<hr>");
    out.print  ( echo );
    out.println("</body>");
    out.println("</html>");
    out.close();
  }

  // @RequestScoped
  static class Monitor  {

    
    private Injector injector;

    @Inject @RequestParameters Map<String, String[]> params;

    // @Inject Monitor()  {}

/*
    @Inject Monitor( Injector injector )  {
      this.injector = injector;
    }
*/

    @Inject
    public void setInjector( Injector injector )  {
      this.injector = injector;
      System.out.println( "injector!!" );
    }


    public void display()  {

      HttpServletRequest request =
            injector.getInstance( HttpServletRequest.class );
      HttpServletResponse response =
            injector.getInstance( HttpServletResponse.class );
      HttpSession session =
            injector.getInstance( HttpSession.class );

      System.out.printf(
        "injector = %s\n\nrequest = %s\n\nresponse = %s\n\nsession = %s\n\nparams = %s\n\n",
        injector.toString(), request.toString(), response.toString(), session.toString(), params.toString() );
    }

    public void finalize()  {
      System.out.println( "finalize!!" );
    }

  }

}
